  // The Colour Chooser Applet Exercise

 import java.applet.*;
 import javax.swing.*;
 import java.awt.*;
 import java.awt.event.*;


  public class ColorChooserApplication extends JFrame implements ActionListener, AdjustmentListener
  {
	
	private JScrollBar rBar, gBar, bBar;
	private JTextField rField, gField, bField;
	private ColorCanvas cs;
	
	public ColorChooserApplication()
	{
	  super("Colour Chooser Application");
	  JPanel rightPanel = new JPanel(new GridLayout(3,3));
	  
	  rightPanel.add(new JLabel("Red:"));
	  rBar = new JScrollBar(JScrollBar.HORIZONTAL, 128, 10, 0, 265);
	  rBar.addAdjustmentListener(this);
	  rightPanel.add(rBar);
	  rField = new JTextField("128",10);
	  rField.addActionListener(this);
	  rightPanel.add(rField);

	  rightPanel.add(new JLabel("Green:"));
	  gBar = new JScrollBar(JScrollBar.HORIZONTAL, 128, 10, 0, 265);
	  gBar.addAdjustmentListener(this);
	  rightPanel.add(gBar);
	  gField = new JTextField("128");
	  gField.addActionListener(this);
	  rightPanel.add(gField);

	  rightPanel.add(new JLabel("Blue:"));
	  bBar = new JScrollBar(JScrollBar.HORIZONTAL, 128, 10, 0, 265);
	  bBar.addAdjustmentListener(this);
	  rightPanel.add(bBar);
	  bField = new JTextField("128");
	  bField.addActionListener(this);
	  rightPanel.add(bField);

	  cs = new ColorCanvas();
	  cs.setSize(100,100);
	  this.getContentPane().setLayout(new FlowLayout());
	  this.getContentPane().add(cs);
	  this.getContentPane().add(rightPanel);
	  this.updateColor();
	  this.setSize(500,150);
	  this.setVisible(true);
	}

	// Since no invalid value is possible with the scrollbar error checking is not required.
	public void adjustmentValueChanged(AdjustmentEvent e) 
	{
	  rField.setText(new Integer(rBar.getValue()).toString());
	  gField.setText(new Integer(gBar.getValue()).toString());
	  bField.setText(new Integer(bBar.getValue()).toString());
	  this.updateColor();
	}

	//actionPerformed is a little complex as the user could type in values
	//>255 <0 or even enter an invalid string
	public void actionPerformed(ActionEvent e) 
	{
	  try
	  {
	    Integer rVal = new Integer(rField.getText());
	    Integer gVal = new Integer(gField.getText());
	    Integer bVal = new Integer(bField.getText());
	    int rValInt = rVal.intValue();
	    int gValInt = gVal.intValue();
	    int bValInt = bVal.intValue();

	    if(rValInt>=0 && rValInt<=255) rBar.setValue(rValInt);
		else throw(new NumberFormatException());
	    if(gValInt>=0 && gValInt<=255) gBar.setValue(gValInt);
		else throw(new NumberFormatException());
	    if(bValInt>=0 && bValInt<=255) bBar.setValue(bValInt);
		else throw(new NumberFormatException());
	  } 
	  catch (NumberFormatException nfe)
	  {
	    rField.setText(new Integer(rBar.getValue()).toString());
	    gField.setText(new Integer(gBar.getValue()).toString());
	    bField.setText(new Integer(bBar.getValue()).toString());
	  }
	  updateColor();
	}

	// I use the scrollbars as storage rather than states
	private void updateColor()
	{
	   Color c = new Color(rBar.getValue(), gBar.getValue(), bBar.getValue());
	   cs.updateColor(c);
	}
	
	public static void main(String args[])
	{
		System.out.println("Application Started.");
		new ColorChooserApplication();
	}
  }


  class ColorCanvas extends Canvas
  {
	private Color col;

	public void updateColor(Color c)
	{
	  this.col = c;
	  repaint();
	}

	public void paint(Graphics g)
	{
	  g.setColor(col);
	  g.fillRect(0,0,100,100);
	}
  }