// A Working Counting Applet - by Derek Molloy

import java.applet.*;
import java.awt.*;
import java.awt.event.*;

public class CounterApplication extends Frame implements ActionListener
{
	private Button start, stop, pause;
	private TextField countField1;
	private Counter theCounter1;

	public CounterApplication() 
	{
	  super("Counter Application");
	  this.setLayout(new FlowLayout());
	  countField1 = new TextField(10);
	  this.add(countField1);

	  start = new Button("Start");
	  start.addActionListener(this);
	  this.add(start);

	  stop = new Button("Stop");
	  stop.addActionListener(this);
	  this.add(stop);

	  pause = new Button("Pause");
	  pause.addActionListener(this);
	  this.add(pause);

	  this.theCounter1 = new Counter(countField1, 100, 0);
	  
	  this.setSize(300,100);
	  this.setVisible(true);
	}
	
	public void actionPerformed(ActionEvent e) 
	{
	  if (e.getSource().equals(start))
	  {
	    this.theCounter1.start();
	  }
	  else if (e.getSource().equals(stop))
	  {
	    this.theCounter1.stopCounter();
	  }
	  else if (e.getSource().equals(pause))
	  {
	    this.theCounter1.toggleCounter();
	  }
	}
	
	public static void main(String args[])
	{
		new CounterApplication();
	}
} 

class Counter extends Thread
{
	private int count, delay;
	private boolean running = true, paused = false;
	private TextField theField;

	
	public Counter(TextField t, int delay, int startValue)
	{
	  this.theField = t;
	  this.count = startValue;
	  this.delay = delay;
	}

	public void run() 
	{
	  while (running) 
	  {
	    theField.setText("Count: "+this.count++);
	    try 
	    { 
	      Thread.currentThread().sleep(this.delay); 

	      synchronized(this) {
                    while (paused)
                        wait();
              }
	    } 
	    catch (InterruptedException e)
	    {  
		theField.setText("Interrupted!");
		this.stopCounter();
	    }   
	  }
	}

	public int getCount() { return count; }

	public void stopCounter() { this.running = false; }

	public synchronized void toggleCounter()
	{ 
	  this.paused = !this.paused; 
	  if (!this.paused) notify();
	}
}
